<template>
    <div class="edit-view">
        <el-form :model="formData" :rules="rules" ref="form" label-width="66px" label-position="right" size="small"
                 style="max-width: 500px;">
                <el-form-item prop="userId" label="用户ID">
                            <el-input-number type="number" v-model="formData.userId"></el-input-number>
                </el-form-item>
                <el-form-item prop="jobNumber" label="工号">
                            <el-input-number type="number" v-model="formData.jobNumber"></el-input-number>
                </el-form-item>
                <el-form-item prop="area" label="区域">
                            <el-input v-model="formData.area"></el-input>
                </el-form-item>
                <el-form-item prop="signIn" label="签到">
                            <el-switch v-model="formData.signIn"></el-switch>
                </el-form-item>
                <el-form-item prop="experience" label="经验值">
                            <el-input v-model="formData.experience"></el-input>
                </el-form-item>
                <el-form-item prop="level" label="等级">
                            <el-input v-model="formData.level"></el-input>
                </el-form-item>
                <el-form-item prop="monetary" label="货币">
                            <el-input-number type="number" v-model="formData.monetary"></el-input-number>
                </el-form-item>
                <el-form-item prop="singular" label="成单数">
                            <el-input v-model="formData.singular"></el-input>
                </el-form-item>
                <el-form-item prop="distance" label="距离">
                            <el-input v-model="formData.distance"></el-input>
                </el-form-item>
                <el-form-item prop="goodReview" label="好评数">
                            <el-input v-model="formData.goodReview"></el-input>
                </el-form-item>
                <el-form-item prop="badReview" label="差评数">
                            <el-input v-model="formData.badReview"></el-input>
                </el-form-item>
                <el-form-item prop="operate" label="操作">
                            <el-input v-model="formData.operate"></el-input>
                </el-form-item>
                <el-form-item prop="blacklist" label="黑名单">
                            <el-switch v-model="formData.blacklist"></el-switch>
                </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving"
                           type="primary">保存</el-button>
                <el-button @click="onDelete" :loading="saving"
                           type="danger" v-if="formData.id">删除
                </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
    export default {
        name: 'RiderEdit',
        created() {
            if (this.$route.query.id) {
                this.$http
                    .get('rider/get/'+this.$route.query.id)
                    .then(res => {
                        this.formData = res;
                    })
                    .catch(e => {
                        console.log(e);
                        this.$message.error(e.error);
                    });
            }
        },
        data() {
            return {
                saving: false,
                formData: {
                },
                rules: {
                },
            }
        },
        methods: {
            onSave() {
                this.$refs.form.validate((valid) => {
                    if (valid) {
                        this.submit();
                    } else {
                        return false;
                    }
                });
            },
            submit() {
                let data = {...this.formData};

                this.saving = true;
                this.$http
                    .post('/rider/save', data, {body: 'json'})
                    .then(res => {
                        this.saving = false;
                        this.$message.success('成功');
                        this.$router.go(-1);
                    })
                    .catch(e => {
                        console.log(e);
                        this.saving = false;
                        this.$message.error(e.error);
                    });
            },
            onDelete() {
                this.$alert('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/rider/del/${this.formData.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                }).catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                })
            },
        }
    }
</script>
<style lang="less" scoped>
</style>
